#include <bits/stdc++.h>
using namespace std;
typedef long long ull;
int MOD=1e9+7;

struct dot{
int x,y;
};

int main()
{
    int m; cin >> m;
    vector<dot> s(m);
    for(int i=0; i<m; i++){
        int a,b; cin >> a >> b;
        s[i].x=a; s[i].y=b;
    }
    vector<ull> maxx(m,0);
    for(int k=0; k<m; k++){
        for(int i=0; i<=k; i++){
            for(int j=0; j<=k; j++){
                ull sol=0;
                for(int t=0; t<=k; t++){
                    sol+=abs(s[i].x-s[t].x)*abs(s[j].y-s[t].y);
                }
                maxx[k]=max(maxx[k],sol);
            }
        }
    }
    for(ull sol : maxx)cout << sol % MOD << '\n';
    return 0;
}